module.exports = function (grunt) {

    // Project configuration.
    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),

        clean: {
            before: {
                src: "build"
            }
        },

        copy: {
            build: {
                expand: true,
                src: [
                    "**",
                    "!node_modules/**",
                    "!Gruntfile.js",
                    "!package.json"
                ],
                dest: "build/"
            }
        },

        uglify: {
            build: {
                expand: true,
                src: 'build/**/*.js'
            }
        },

        cssmin: {
            build: {
                expand: true,
                src: 'build/**/*.css'
            }
        }
    });

    grunt.loadNpmTasks('grunt-contrib-jasmine');
    grunt.loadNpmTasks('grunt-contrib-uglify');
    grunt.loadNpmTasks('grunt-contrib-cssmin');
    grunt.loadNpmTasks('grunt-contrib-copy');
    grunt.loadNpmTasks('grunt-contrib-clean');

    // Default task(s).
    grunt.registerTask('default', [
        'clean:before',
        'copy:build',
        'uglify',
        "cssmin"
    ]);
};
