define(['require', 'angular', 'Apperyio', '$App/crouterconfig', 'routes', 'angular-route', 'angular-animate', 'bootstrap', 'angular-touch', 'angular-collection', 'constants', '$Screens/indexController', '$Directives/backButton', '$Directives/navigateTo', ], function(require, angular, _Appery, routerConfig) {
    var DEPENDENCIES_INDEX = 12;
    var DEPENDENCIES = Array.prototype.slice.call(arguments, DEPENDENCIES_INDEX);
    var __APP_NAME__ = 'MCPE Mods';

    var APP = angular.module(__APP_NAME__, ['Apperyio', 'uiGmapgoogle-maps', 'ngAnimate']).config(["$routeProvider", '$controllerProvider', '$provide', '$locationProvider', '$compileProvider', '$filterProvider', Configuration]).run(["ApperyioHelper", RUN]);

    function Configuration($routeProvider, $controllerProvider, $provide, $locationProvider, $compileProvider, $filterProvider) {

        APP.controller = $controllerProvider.register;
        APP.directive = $compileProvider.directive;
        APP.filter = $filterProvider.register;
        APP.factory = $provide.factory;
        APP.service = $provide.service;

        /**
         * Place for list of pages and routes
         */
        var routes = require('routes');
        $locationProvider.html5Mode({
            enabled: false,
            requireBase: false
        });
        angular.forEach(routes.when, function(route, path) {
            $routeProvider.when(path, routerConfig(route));
        });
        $routeProvider.otherwise(routes.otherwise || routes.
    default);
        /**
         * Global dependencies resolver
         */
        if (DEPENDENCIES.length >= 0) {
            var deps = null;
            for (var i = 0, l = DEPENDENCIES.length; i < l; i++) {
                deps = DEPENDENCIES[i];
                if (angular.isArray(deps) && deps.length > 0 && angular.isArray(deps[0].deps)) {
                    try {
                        for (var j = 0, l2 = deps.length; j < l2; j++) {
                            APP[deps[j].type].call(APP, deps[j].name, deps[j].deps);
                        }
                    } catch (e) {
                        // angular or service level error
                        e.message = 'Error in ' + deps[j].name + "\nMessage: " + e.message;
                        throw new Error(e);
                    }
                }
            }
        }
        APP.controller('indexController', require('$Screens/indexController'));
    }

    function RUN(ApperyioHelper) {
        ApperyioHelper.init(require('constants'));
    }

    return APP;
});