'use strict';

(function(window) {

    require.config({
        baseUrl: "app",
        paths: {
            "text": "../libs/text",
            "require": "../libs/requirejs/require",
            "angular": "../libs/angular/angular.min",
            'angular-route': '../libs/angular-route/angular-route.min',
            "angular-touch": "../libs/angular-touch/angular-touch.min",
            "angular-animate": "../libs/angular-animate/angular-animate.min",
            "angular-collection": "../libs/angular-collection",
            "ui-bootstrap": '../libs/angular-bootstrap/ui-bootstrap-tpls.min',
            "lodash": "../libs/lodash/dist/lodash.min",
            "gmaps": "../libs/angular-google-maps/angular-google-maps.min",
            'Apperyio': '../libs/apperyio/Apperyio',
            'x2js': '../libs/x2js/xml2json',
            '$Libs': '../libs',
            '$App': '../libs/apperyio',
            '$Screens': 'pages',
            '$Modals': 'modals',
            '$Directives': 'directives',
            '$Services': 'services',
            // module aliases
            '$Screen1': 'pages/Screen1'
        },
        waitSeconds: 100,
        shim: {
            'ui-bootstrap': ['angular'],
            "angular": {
                exports: "angular"
            },
            "angular-touch": {
                deps: ['angular']
            },
            "angular-route": {
                deps: ['angular']
            },
            "angular-animate": {
                deps: ['angular']
            },
            "angular-collection": {
                deps: ['angular']
            },
            'gmaps': {
                deps: ['angular']
            },
            'lodash': {
                exports: "_"
            },
            'x2js': {
                exports: 'X2JS'
            }
            // services
        }
    });

    require(["require", "angular", "app", "ui-bootstrap", 'gmaps', "../libs/cordova"

    ], function(require, angular) {
        // Run APP
        angular.bootstrap(document.documentElement, ["MCPE Mods"]);
    });

})(this);