define( [ 'require',
        'lodash',
    '$App/entity/api',
    'services/models'
    ],
function( require, _, EntityAPI ){
    var Entity = EntityAPI.EntityFactory,
        TypeNotFoundError = EntityAPI.TypeNotFoundError,
        models_beam = require( 'services/models' ),

        entityFactory = new Entity( models_beam ),

        extend = _.extend,
        forEach = each = _.each,
        isString = _.isString,
        isFunction = _.isFunction,
        isBoolean = _.isBoolean,
        isUndefined = _.isUndefined,
        isArray = _.isArray,
        map = _.map;

    function CModel( $provide ){

        $provide.factory( 'EntityModel', [ function(  ){
            return function (){
                return entityFactory.get.apply( entityFactory, arguments );
            }
        } ] );

        $provide.factory( 'EntityCollectionService',
            [ 'EntityModel', '$httpCollection', 'Mapping',
        function( EntityModel, $httpCollection, Mapping ){
            function f( name, mapping ){
                this.model_name = name;
                this.options = {};
                this.base_item = EntityModel.bind( EntityModel, this.model_name );
                this.mapping = Mapping( mapping );
            };

            f.prototype = new $httpCollection();
            f.prototype.constructor = f;

            f.prototype.addAll = function( data, options ){
                var result = null;
                if ( isUndefined(options.$$fetched) ){
                    result = each( data, this.base_item );
                } else {
                    result = this.mapping.process( data );
                }
                return $httpCollection.prototype.addAll.call(this, result, options || {});
            };

            f.prototype.getOptions = function(){
                return this.options;
            };

            f.prototype.setOptions = function( options ){
                options || (options = {});
                if (options.comparator !== void 0) this.comparator = options.comparator;
                this.idAttribute = options.idAttribute || this.idAttribute;
                this.options = extend( {}, this.options, options );
            };

            // /**
            //  * Pagination frame getter
            //  * @return Object PlainObject
            //  * {
            //  *      first_prk: 0,
            //  *      last_prk: 100,
            //  *      changed: true/false, // !is_saved === is_changed
            //  *      create_at: {{timestamp}},
            //  *      change_at: {{timestamp}}, // last
            //  *      changed_properties: ['{{property_name}}'] // last or array of fields
            //  * }
            //  */
            // f.prototype.getPageInfo = function(){
            //     return {
            //         first_prk: 0,
            //         last_prk: 100,
            //         changed: true, // !is_saved === is_changed
            //         create_at: '{{timestamp}}',
            //         change_at: '{{timestamp}}', // last
            //         changed_properties: ['{{property_name}}'] // last or array of fields
            //     }
            // };

            // /**
            //  * Pagination change data-frame
            //  * @param  PlainObject params : target frame
            //  * @param  PlainObject options : for example:
            //  * {
            //  *      force: true, // retrieve new frame without saving changes
            //  *      ...other overrides
            //  * }
            //  * @return Promise         $q.promise
            //  */
            // f.prototype.changePage = function( params, options ){
            //     var def = $q.defer();
            //     // #TODO:
            //     return def.promise;
            // };

            return f;
        } ] );

    };

    return CModel;
});
