define( [ 'lodash' ], function( _ ){
	var extend = _.extend,
		forEach = each = _.each,
		isString = _.isString,
		isFunction = _.isFunction,
		isArray = _.isArray,
		map = _.map;
	return function httpCollection($collection, Rest, Apperyio) {
		var httpCollection;
		//Rest = new Rest;

		function httpCollection(){
			this.$rest = Rest;
		};
		httpCollection.prototype = $collection.getInstance();
		httpCollection.prototype.constructor = httpCollection;

		httpCollection.prototype.options = {
			http: {
				get: {
					url: '',
					method: 'GET',
				},
				save: {
					url: '',
					method: 'POST',
				},
				update: {
					url: '',
					method: 'PUT'
				},
				/**
				 * #TODO: Implementation
				 * @type {Object}
				 */
				remove: {
					url: '',
					method: 'DELETE'
				}
			}
		};

		httpCollection.prototype.getOptions = function(){
			return this.options;
		};

		httpCollection.prototype.setOptions = function( options ){
			this.options = extend( {}, this.options, options );
		};

		httpCollection.prototype.getResponse = function(){
			return this.$rest.getResponse();
		};

		httpCollection.prototype.getRequest = function(){
			return this.$rest.getRequest();
		};

		httpCollection.prototype.fetch = function( force ) {
			var self = this,
				_first = this.size() === 0 || !!force,
				_action = this.update;

			if (_first) {
				_action = function(obj, options){
					self._reset();
					self.addAll( obj, options );
				}
			}

			return this.$rest.execute(this.options.http.get)
				.success(function(data, status, headers, config) {
					/**
					 * TODO
					 */
					self.current = null;

					_action.call(self, data, {
						$$new: false,
						$$fetched: true
					});
				})
				.error(function(data, status, headers, config) {
					/**
					 * TODO
					 */
					console.log(arguments);
				});
		};

			/**
			 * Save updates or new items of objects.
			 *
			 * TODO: Add Caching and counter for deffered save
			 *       after {{number}} updates in collection ($evalAsync)
			 *
			 * TODO: Add success && error handlers
			 *
			 * @return Collection
			 */
		httpCollection.prototype.save = function() {
			var that = this;
			forEach(this.where('$$new', true), function(value) {
				delete value.$$new;
				this.$rest.execute({
					method: that.options.http.save.method,
					url: Apperyio.url(that.options.http.save.url, value),
					data: value
				}).success(function() { });
			});
			forEach(this.where('$$modified', true), function(value) {
				delete value.$$modified;
				this.$rest.execute({
					method: that.options.http.update.method,
					url: Apperyio.url(that.options.http.update.url, value),
					data: value
				}).success(function() { });
			});
		};
		httpCollection.prototype.add = function(obj, options){
			if (options && options.hasOwnProperty('$$new')){
				//obj.$$new = true;

				/**
				 * We need to hide list of collection fields those
				 * fields can't be pushed with update request (PUT)
				 */
				forEach(['_id', '_createdAt', '_updatedAt'], function(value){
					obj['$$' + value] = obj[value];
					delete obj[value];
				});
			}
			return $collection.prototype.add.call(this, obj, options || {});
		};
		httpCollection.prototype.update = function(obj){
			var existing;
			existing = this.get(obj);
			if (existing) {
				obj.$$modified = true;
				console.group( 'Update Object' );
				console.log( obj );
				console.groupEnd('Update Object');
				extend(existing, obj);
			}
			if (!existing) this.add(obj);
			return this;
		};

		httpCollection.extend = function(){
			$collection.extend.apply(httpCollection, arguments);
		};

		httpCollection.getInstance = function(){
			$collection.getInstance.apply(httpCollection, arguments);
		};

		return httpCollection;
	};
});

