define( [ 'require', '$squire' ], function( require, Squire ){

    /**
     * resolve dependencies and call callback
     *
     * @param  {Dictionary}   deb_pairs pairs str:str or str:function
     * @param  {String|Array[String]}   target    target module
     * @param  {Function} callback
     * @return
     */
    function resolve( deb_pairs, target, callback ){
        var mocks = _.values( deb_pairs );
        mocks = _.filter(mocks, function(item){ return _.isString(item); });
        require( mocks, function(){
            var injector = new Squire();
            _.each( deb_pairs, function( mock, dep ){
                mock = _.isObject(mock) ? mock : require( mock );
                injector.mock( dep, mock );
            });

            if ( !_.isArray(target) ){
                target = [target];
            }

            injector.require( target, callback );
        });
    };

    return resolve;
});
